import unittest
from csst_common.status import CsstStatus, CsstResult
from csst_common import parameterized_module_decorator


class TestDecorator(unittest.TestCase):
    def test_parameterized_module_decorator(self):
        @parameterized_module_decorator()
        def call_add(a, b):
            if isinstance(a, float) and isinstance(b, float):
                return CsstResult(CsstStatus.PERFECT, files=None, result=a + b)
            else:
                return CsstResult(CsstStatus.ERROR, files=None, result=a + b)

        mres_int = call_add(1, 2)
        self.assertEqual(mres_int.module, "call_add")
        self.assertGreater(mres_int.cost, 0)
        self.assertTrue(mres_int.status, CsstStatus(2))

        mres_float = call_add(1, 2)
        self.assertEqual(mres_float.module, "call_add")
        self.assertGreater(mres_float.cost, 0)
        self.assertTrue(mres_float.status, CsstStatus(0))
